#include "strops.h"
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include <stdio.h>

/* Function template
char* strops_(const char* string) {
    char *result = malloc(strlen(string));
    memcpy(result, string, strlen(string));
    return result;
}
*/

char* strops_to_lowercase(const char* string) {
    char *result = malloc(strlen(string));
    memcpy(result, string, strlen(string));
    size_t i;
    for(i = 0; i < strlen(string); i++) {
        if (result[i] >= 'A' && result[i] <= 'Z') {
            result[i] += 32;
        }
    }
    return result;
}

char* strops_to_uppercase(const char* string) {
    char *result = malloc(strlen(string));
    memcpy(result, string, strlen(string));
    size_t i;
    for(i = 0; i < strlen(string); i++) {
        if (result[i] >= 'a' && result[i] <= 'z') {
            result[i] -= 32;
        }
    }
    return result;
}

char* strops_remove_at_pos(const char* string, size_t pos) {
    char *result = malloc(strlen(string));
    memcpy(result, string, strlen(string));
    result[pos] = 0;
    size_t i;
    for(i = pos; i < strlen(string); i++) {
        result[i] = result[i + 1];
    }
    result = realloc(result, strlen(result));
    return result;
}

char* strops_trim_right_whitespace(const char* string) {
    char *result = malloc(strlen(string));
    memcpy(result, string, strlen(string));
    while(strchr("\t\n\v\f\r ", result[strlen(result) - 1]) != NULL) {
        result = strops_remove_at_pos(result, strlen(result) - 1);
    }
    result = realloc(result, strlen(result));
    return result;
}

char* strops_trim_left_whitespace(const char* string) {
    char *result = malloc(strlen(string));
    memcpy(result, string, strlen(string));
    while(strchr("\t\n\v\f\r ", result[0]) != NULL) {
        result = strops_remove_at_pos(result, 0);
    }
    result = realloc(result, strlen(result));
    return result;
}

char* strops_trim_both_whitespace(const char* string) {
    char *result = malloc(strlen(string));
    memcpy(result, string, strlen(string));
    result = strops_trim_right_whitespace(result);
    result = strops_trim_left_whitespace(result);
    return result;
}
